B::Concise(3)

NAME
B::Concise - Walk Perl syntax tree, printing concise info about ops

SYNOPSIS
    perl -MO=Concise[,OPTIONS] foo.pl

    use B::Concise qw(set_style add_callback);

DESCRIPTION
This compiler backend prints the internal OPs of a Perl program's syntax tree in one of several space-efficient text formats suitable for debugging the inner workings of perl or other compiler backends. It can print OPs in the order they appear in the OP tree, in the order they will execute, or in a text approximation to their tree structure, and the format of the information displyed is customizable. Its function is similar to that of perl's -Dx debugging flag or the B::Terse module, but it is more sophisticated and flexible.

EXAMPLE
Here's is a short example of output, using the default formatting conventions :

    % perl -MO=Concise -e '$a = $b + 42'
    8  <@> leave[t1] vKP/REFC ->(end)
    1     <0> enter ->2
    2     <;> nextstate(main 1 -e:1) v ->3
    7     <2> sassign vKS/2 ->8
    5        <2> add[t1] sK/2 ->6
    -           <1> ex-rv2sv sK/1 ->4
    3              <$> gvsv(*b) s ->4
    4           <$> const(IV 42) s ->5
    -        <1> ex-rv2sv sKRM*/1 ->7
    6           <$> gvsv(*a) s ->7

Each line corresponds to an operator. Null ops appear as "ex-opname", where opname is the op that has been optimized away by perl.

The number on the first row indicates the op's sequence number. It's given in base 36 by default.

The symbol between angle brackets indicates the op's type : for example, <2> is a BINOP, <@> a LISTOP, etc. (see "OP class abbreviations").

The opname may be followed by op-specific information in parentheses (e.g. "gvsv(*b)"), and by targ information in brackets (e.g. "leave[t1]").

Next come the op flags. The common flags are listed below ("OP flags abbreviations"). The private flags follow, separated by a slash. For example, "vKP/REFC" means that the leave op has public flags OPf_WANT_VOID, OPf_KIDS, and OPf_PARENS, and the private flag OPpREFCOUNTED.

Finally an arrow points to the sequence number of the next op.

OPTIONS
Arguments that don't start with a hyphen are taken to be the names of subroutines to print the OPs of; if no such functions are specified, the main body of the program (outside any subroutines, and not including use'd or require'd files) is printed.

-basic
    Print OPs in the order they appear in the OP tree (a preorder traversal, starting at the root). The indentation of each OP shows its level in the tree. This mode is the default, so the flag is included simply for completeness.

-exec
    Print OPs in the order they would normally execute (for the majority of constructs this is a postorder traversal of the tree, ending at the root). In most cases the OP that usually follows a given OP will appear directly below it; alternate paths are shown by indentation. In cases like loops when control jumps out of a linear path, a 'goto' line is generated.

-tree
    Print OPs in a text approximation of a tree, with the root of the tree at the left and 'left-to-right' order of children transformed into 'top-to-bottom'. Because this mode grows both to the right and down, it isn't suitable for large programs (unless you have a very wide terminal).

-compact
    Use a tree format in which the minimum amount of space is used for the lines connecting nodes (one character in most cases). This squeezes out a few precious columns of screen real estate.

-loose
    Use a tree format that uses longer edges to separate OP nodes. This format tends to look better than the compact one, especially in ASCII, and is the default.

-vt Use tree connecting characters drawn from the VT100 line-drawing set. This looks better if your terminal supports it.

-ascii
    Draw the tree with standard ASCII characters like "+" and "|". These don't look as clean as the VT100 characters, but they'll work with almost any terminal (or the horizontal scrolling mode of less(1)) and are suitable for text documentation or email. This is the default.

-main
    Include the main program in the output, even if subroutines were also specified.

-basen
    Print OP sequence numbers in base n. If n is greater than 10, the digit for 11 will be 'a', and so on. If n is greater than 36, the digit for 37 will be 'A', and so on until 62. Values greater than 62 are not currently supported. The default is 36.

-bigendian
    Print sequence numbers with the most significant digit first. This is the usual convention for Arabic numerals, and the default.

-littleendian
    Print seqence numbers with the least significant digit first.

-concise
    Use the author's favorite set of formatting conventions. This is the default, of course.

-terse
    Use formatting conventions that emulate the ouput of B::Terse. The basic mode is almost indistinguishable from the real B::Terse, and the exec mode looks very similar, but is in a more logical order and lacks curly brackets. B::Terse doesn't have a tree mode, so the tree mode is only vaguely reminiscient of B::Terse.

-linenoise
    Use formatting conventions in which the name of each OP, rather than being written out in full, is represented by a one- or two-character abbreviation. This is mainly a joke.

-debug
    Use formatting conventions reminiscient of B::Debug; these aren't very concise at all.

-env
    Use formatting conventions read from the environment variables "B_CONCISE_FORMAT", "B_CONCISE_GOTO_FORMAT", and "B_CONCISE_TREE_FORMAT".

FORMATTING SPECIFICATIONS
For each general style ('concise', 'terse', 'linenoise', etc.) there are three specifications: one of how OPs should appear in the basic or exec modes, one of how 'goto' lines should appear (these occur in the exec mode only), and one of how nodes should appear in tree mode. Each has the same format, described below. Any text that doesn't match a special pattern is copied verbatim.

(x(exec_text;basic_text)x)
    Generates exec_text in exec mode, or basic_text in basic mode.

(*(text)*)
    Generates one copy of text for each indentation level.

(*(text1;text2)*)
    Generates one fewer copies of text1 than the indentation level, followed by one copy of text2 if the indentation level is more than 0.

(?(text1#varText2)?)
    If the value of var is true (not empty or zero), generates the value of var surrounded by text1 and Text2, otherwise nothing.

#var
    Generates the value of the variable var.

#varN
    Generates the value of var, left jutified to fill N spaces.

~   Any number of tildes and surrounding whitespace will be collapsed to a single space.

The following variables are recognized:

#addr
    The address of the OP, in hexidecimal.

#arg
    The OP-specific information of the OP (such as the SV for an SVOP, the non-local exit pointers for a LOOP, etc.) enclosed in paretheses.

#class
    The B-determined class of the OP, in all caps.

#classsym
    A single symbol abbreviating the class of the OP.

#coplabel
    The label of the statement or block the OP is the start of, if any.

#exname
    The name of the OP, or 'ex-foo' if the OP is a null that used to be a foo.

#extarg
    The target of the OP, or nothing for a nulled OP.

#firstaddr
    The address of the OP's first child, in hexidecimal.

#flags
    The OP's flags, abbreviated as a series of symbols.

#flagval
    The numeric value of the OP's flags.

#hyphseq
    The sequence number of the OP, or a hyphen if it doesn't have one.

#label
    'NEXT', 'LAST', or 'REDO' if the OP is a target of one of those in exec mode, or empty otherwise.

#lastaddr
    The address of the OP's last child, in hexidecimal.

#name
    The OP's name.

#NAME
    The OP's name, in all caps.

#next
    The sequence number of the OP's next OP.

#nextaddr
    The address of the OP's next OP, in hexidecimal.

#noise
    The two-character abbreviation for the OP's name.

#private
    The OP's private flags, rendered with abbreviated names if possible.

#privval
    The numeric value of the OP's private flags.

#seq
    The sequence number of the OP.

#seqnum
    The real sequence number of the OP, as a regular number and not adjusted to be relative to the start of the real program. (This will generally be a fairly large number because all of B::Concise is compiled before your program is).

#sibaddr
    The address of the OP's next youngest sibling, in hexidecimal.

#svaddr
    The address of the OP's SV, if it has an SV, in hexidecimal.

#svclass
    The class of the OP's SV, if it has one, in all caps (e.g., 'IV').

#svval
    The value of the OP's SV, if it has one, in a short human-readable format.

#targ
    The numeric value of the OP's targ.

#targarg
    The name of the variable the OP's targ refers to, if any, otherwise the letter t followed by the OP's targ in decimal.

#targarglife
    Same as #targarg, but followed by the COP sequence numbers that delimit the variable's lifetime (or 'end' for a variable in an open scope) for a variable.

#typenum
    The numeric value of the OP's type, in decimal.

ABBREVIATIONS

  OP flags abbreviations
    v      OPf_WANT_VOID    Want nothing (void context)
    s      OPf_WANT_SCALAR  Want single value (scalar context)
    l      OPf_WANT_LIST    Want list of any length (list context)
    K      OPf_KIDS         There is a firstborn child.
    P      OPf_PARENS       This operator was parenthesized.
                             (Or block needs explicit scope entry.)
    R      OPf_REF          Certified reference.
                             (Return container, not containee).
    M      OPf_MOD          Will modify (lvalue).
    S      OPf_STACKED      Some arg is arriving on the stack.
    *      OPf_SPECIAL      Do something weird for this op (see op.h)

  OP class abbreviations
    0      OP (aka BASEOP)  An OP with no children
    1      UNOP             An OP with one child
    2      BINOP            An OP with two children
    |      LOGOP            A control branch OP
    @      LISTOP           An OP that could have lots of children
    /      PMOP             An OP with a regular expression
    $      SVOP             An OP with an SV
    "      PVOP             An OP with a string
    {      LOOP             An OP that holds pointers for a loop
    ;      COP              An OP that marks the start of a statement
    #      PADOP            An OP with a GV on the pad

Using B::Concise outside of the O framework
It is possible to extend B::Concise by using it outside of the O framework and providing new styles and new variables.

    use B::Concise qw(set_style add_callback);
    set_style($format, $gotofmt, $treefmt);
    add_callback
    (
        sub
        {
            my ($h, $op, $level, $format) = @_;
            $h->{variable} = some_func($op);
        }
    );
    B::Concise::compile(@options)->();

You can specify a style by calling the set_style subroutine. If you have a new variable in your style, or you want to change the value of an existing variable, you will need to add a callback to specify the value for that variable.

This is done by calling add_callback passing references to any callback subroutines. The subroutines are called in the same order as they are added. Each subroutine is passed four parameters. These are a reference to a hash, the keys of which are the names of the variables and the values of which are their values, the op, the level and the format.

To define your own variables, simply add them to the hash, or change existing values if you need to. The level and format are passed in as references to scalars, but it is unlikely that they will need to be changed or even used.

To see the output, call the subroutine returned by compile in the same way that O does.

AUTHOR
Stephen McCamant, "smcc@CSUA.Berkeley.EDU"